<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2018 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

class db_logger {
	
	var $min_query_time = MIN_QUERYTIME_LOG;


    function __construct() {
        $this->query_array = array();
        $this->query_count = array();
        $this->total_queries = 0;
        $this->total_query_time = 0;
        
        $this->query_tables['tables']['xt_products']['count']=0;
        $this->query_tables['tables']['xt_products']['time']=0;
        
        $this->query_tables['tables']['xt_seo_url']['count']=0;
        $this->query_tables['tables']['xt_seo_url']['time']=0;
        
        $this->query_tables['tables']['xt_plugin_products']['count']=0;
        $this->query_tables['tables']['xt_plugin_products']['time']=0;
        
        $this->query_tables['tables']['xt_media']['count']=0;
        $this->query_tables['tables']['xt_media']['time']=0;
        
        $this->query_tables['tables']['xt_seo_url']['count']=0;
        $this->query_tables['tables']['xt_seo_url']['time']=0;
        
        $this->query_tables['tables']['xt_products_reviews']['count']=0;
        $this->query_tables['tables']['xt_products_reviews']['time']=0;
        
        $this->query_tables['tables']['xt_plg_products_to_attributes']['count']=0;
        $this->query_tables['tables']['xt_plg_products_to_attributes']['time']=0;
        
    }
    

    function addQuery($sql,$time) {

    //	if (strpos($sql,'19544'))
    // 			debug_print_backtrace();
    	
        $this->total_queries+=1;
        $this->total_query_time+=$time;

        if ($time<$this->min_query_time) return;
        
        $hash = md5($sql);
        
        if (strpos($sql,'xt_products')) {
        	$this->query_tables['tables']['xt_products']['count']+=1;
        	$this->query_tables['tables']['xt_products']['time']+=$time;
        }
        
        if (strpos($sql,'xt_plugin_products')) {
        	$this->query_tables['tables']['xt_plugin_products']['count']+=1;
        	$this->query_tables['tables']['xt_plugin_products']['time']+=$time;
        }
        
        if (strpos($sql,'xt_media')) {
        	$this->query_tables['tables']['xt_media']['count']+=1;
        	$this->query_tables['tables']['xt_media']['time']+=$time;
        }
        
        if (strpos($sql,'xt_seo_url')) {
        	$this->query_tables['tables']['xt_seo_url']['count']+=1;
        	$this->query_tables['tables']['xt_seo_url']['time']+=$time;
        }
        
        if (strpos($sql,'xt_products_reviews')) {
        	$this->query_tables['tables']['xt_products_reviews']['count']+=1;
        	$this->query_tables['tables']['xt_products_reviews']['time']+=$time;
        }
        
        if (strpos($sql,'xt_plg_products_to_attributes')) {
        	$this->query_tables['tables']['xt_plg_products_to_attributes']['count']+=1;
        	$this->query_tables['tables']['xt_plg_products_to_attributes']['time']+=$time;
        }
        
        $this->query_array[]=time().'|'.$time.'|'.$sql;
        
        
        
        if (isset($this->query_count[$hash])) {
            $this->query_count[$hash]['count']+=1;
            $this->query_count[$hash]['total_time']+=$time;
        } else {
            $this->query_count[$hash]=array('sql'=>$sql,'total_time'=>$time,'count'=>1);
        }
        
        // log different tables
        
        
    }
    
    function _showMultipleQueries($min_amount=2,$table_filter = '') {
    	
    	if ($min_amount>0) {
    	foreach ($this->query_count as $key => $val) {
    		if ($val['count']<$min_amount) unset($this->query_count[$key]);
    	}
    	}
    	
    	if ($table_filter!='') {
    		foreach ($this->query_array as $key => $val) {
    			if (!strpos($val,$table_filter)) unset($this->query_array[$key]);
    		}
    	}
    	
    	__debug($this->query_array);
    	__debug($this->query_tables);
    	
    }
}

